function skysub, file, biassec, datasec, distpoly, wavepoly
objrange=[1020,1220] ; yslit range ocupied by object
windowsky=100

; ------------------- read science file
;data0=mrdfits(file, 0, hdr, /DSCALE)
;data=oscansub(data0, biassec, datasec)
;mwrfits, data, 'data.fits', /create

data=file

nx=(size(data))[1]
ny=(size(data))[2]
xarr=dblarr(nx, ny)
yarr=dblarr(nx, ny)
lamarr=dblarr(nx, ny)
ysarr=dblarr(nx, ny)

for i=0, ny-1 do xarr[*,i]=dindgen(nx)
for i=0, nx-1 do yarr[i,*]=dindgen(ny)

;lamarr=poly_xy(xarr, yarr, wavepoly)
;ysarr=poly_xy(xarr, yarr, distpoly)
for i=0, nx-1 do lamarr[i,*]=sfiteval(xarr[i,*], yarr[i,*], 6, kx=wavepoly, /IRREGULAR, /MAX_DEGREE)
for i=0, nx-1 do ysarr[i,*]=sfiteval(xarr[i,*], yarr[i,*], 4, kx=distpoly, /IRREGULAR, /MAX_DEGREE)



selsky=where((ysarr lt objrange[0] and ysarr gt objrange[0]-windowsky) or (ysarr gt objrange[1] and ysarr lt objrange[1]+windowsky))
skyarr=data[selsky]
lamskyarr=lamarr[selsky]
;skyarr=data[*,10:15]
;lamskyarr=lamarr[*,10:15]
errskyarr=sqrt(skyarr)
errskyarr[where(skyarr le 0)]=abs(median(errskyarr))*10

fullbkpt=bspline_bkpts(lamskyarr, nord=4, nbkpts=3000)
sset=bspline_iterfit(lamskyarr, skyarr, fullbkpt=fullbkpt, invvar=1./errskyarr^2, upper=3, lower=3)
sky  = bspline_valu(lamskyarr, sset)


window, 0, xsize=1200, ysize=600
plot, lamskyarr, skyarr, psym=3, yrange=[0,30], xrange=[5550, 6500], xstyle=1
oplot, lamskyarr, sky, color=250, psym=2

stop

skyfitarr=dblarr(nx, ny)
for i=0, ny-1 do skyfitarr[*,i]=bspline_valu(lamarr[*,i], sset)
   
datasub=data-skyfitarr
mwrfits, datasub, 'datasub.fits', /create
mwrfits, skyfitarr, 'skyfit.fits', /create

return, datasub

end
