;FIND X COORDINATE AND FWHM OF SLIT FOR EACH ROW
;file = filename of slit image frame
;x0 = first guess at slit x position
;dx = width of window for gaussian fit
;dy = height of window for gaussian fit
;
; TO DO:
; - get biassec and datasec from header

function traceslit, file, biassec, datasec, x0

;x0=1411.
dx=40.
dy=20.

;biassec=[4069,4186,864,3154]
;datasec=[0,4063,859,3159]

data0=mrdfits(file, 0, hdr, /DSCALE)
data=oscansub(data0, biassec, datasec)

nx=(size(data))[1]
ny=(size(data))[2]


xslit=dblarr(ny,2)
xarr=dindgen(nx)

for i=0, ny-1 do begin
   auxx=xarr[fix(x0-dx/2.):fix(x0+dx/2.)]
   auxy=total(data[max([0,fix(x0-dx/2.)]):min([nx-1,fix(x0+dx/2.)]),max([0,fix(i-dy/2.)]):min([ny-1,fix(i+dy/2.)])], 2)
   fit=GAUSSFIT(auxx, auxy, coef, NTERMS=4)
   xslit[i,0]=coef[1]
   xslit[i,1]=coef[2]*2.355
;plot, auxx, fit, title='ROW '+strtrim(string(i),2)
;oplot, auxx,  auxy, psym=2, color=250
;pause

endfor

return, xslit


end
